import os
import glob


def get_quadkey_functions():
    """
    Get all SQL files in the `quadkeyfunctions` directory.

    Returns:
        Iterable with SQL functions as string
    """

    dir_path = os.path.dirname(os.path.realpath(__file__))
    file_search_path = os.path.join(dir_path, "*.sql")
    files = glob.glob(file_search_path)
    for file in files:
        with open(file, "r") as f:
            yield f.read()
